#ifndef LIB_MQLPLUS_BASE_OBJECT_LINKED_LIST_NODE_MQH_INCLUDED
#define LIB_MQLPLUS_BASE_OBJECT_LINKED_LIST_NODE_MQH_INCLUDED
#property version "1.0";
/**********************************************************************************
 * Copyright (C) 2010-2022 Dominik Egert <info@freie-netze.de>
 *
 * This file is the objects include file.
 *
 * MQLplus, including this file may not be copied and/or distributed
 * without explecit permit by the author.
 * Author Dominik Egert / Freie Netze UG.
 **********************************************************************************
 *
 *  Version: 1.0
 *  State: production
 *
 *  File information
 *  ================
 *
 *
 *
*/
#ifdef DBG_MSG_TRACE_FILE_LOADER
    DBG_MSG_TRACE_FILE_LOADER;

#endif



// Incluse base node object
#include "lib_base_obj_node.mqh"





/*********************************************************************************************************************************************************/
/*                                                                                                                                                       */
/* MQLplus data structures                                                                                                                               */
/*                                                                                                                                                       */
/*********************************************************************************************************************************************************/


    ///////////////////////////////////////
    //
    //  Object List Node
    //

    // Base List object

        template <typename USER_DATA>
        class _object_l_node : public _object_node<USER_DATA, _object_l_node<USER_DATA>>
        {
            public:
            // Constructors / Destructor

                // Default constructor
                _object_l_node() :
                    _object_node()
                { };

                // Copy constructor
                _object_l_node(const _object_l_node<USER_DATA>& p_in)
                {
                    remove();
                    _object_node<USER_DATA, _object_l_node<USER_DATA>>(p_in);
                };

                // Destructor
                ~_object_l_node()
                { remove(); };


            protected:
            // List node operations

                // Prepend node
                void prepend(_object_l_node<USER_DATA>& p_in)
                {
                    _object_l_node* ptr_obj = (_left == NULL) ? ::GetPointer(this) : left();
                    ptr_obj._left         	= ::GetPointer(p_in);
                    p_in._right             = ptr_obj;
                };

                // Append node
                void append(_object_l_node<USER_DATA>& p_in)
                {
                    _object_l_node* ptr_obj = (_right == NULL) ? ::GetPointer(this) : right();
                    ptr_obj._right          = ::GetPointer(p_in);
                    p_in._left            	= ptr_obj;
                };

                // Insert node
                void insert(_object_l_node<USER_DATA>& p_in)
                {
                    p_in._left            	= _left;
                    p_in._right             = ::GetPointer(this);
                    _left._right          	= ::GetPointer(p_in);
                    _left                 	= _left._right;
                };

            public:
                // Remove element
                void remove()
                {
                    if(_left != NULL)
                    { _left._right = _right; }

                    if(_right != NULL)
                    { _right._left = _left; }
                    _left 	= NULL;
                    _right  = NULL;
                };


            // Operators

                // Assignment operator
                void operator=(const _object_l_node<USER_DATA>& p_in)
                {
                    remove();
                    _left     	= p_in._left;
                    _right      = p_in._right;
                    this_obj    = p_in.this_obj;
                };


                // Access operator
                _object_l_node<USER_DATA>* operator[](const int idx)
                {
                    int count = NULL;
                    _object_l_node<USER_DATA>* ptr_obj = (_object_l_node<USER_DATA>*)top();
                    while( (ptr_obj._right != NULL)
                        && (count < idx)
                        && (!_StopFlag) )
                    {
                        ptr_obj = ptr_obj._right;
                        count++;
                    }

                    // Return
                    return(ptr_obj);
                };
        };



//
// END MQL data structures                                                                                                                                */
//*********************************************************************************************************************************************************/
#endif // LIB_MQLPLUS_BASE_OBJECT_LINKED_LIST_NODE_MQH_INCLUDED
