#ifndef LIB_MQLPLUS_BASE_OBJECT_MAP_RB_TREE_NODE_MQH_INCLUDED
#define LIB_MQLPLUS_BASE_OBJECT_MAP_RB_TREE_NODE_MQH_INCLUDED
#property version "1.0";
/**********************************************************************************
 * Copyright (C) 2010-2022 Dominik Egert <info@freie-netze.de>
 *
 * This file is the objects include file.
 *
 * MQLplus, including this file may not be copied and/or distributed
 * without explecit permit by the author.
 * Author Dominik Egert / Freie Netze UG.
 **********************************************************************************
 *
 *  Version: 1.0
 *  State: production
 *
 *  File information
 *  ================
 *
 *
 *
*/
#ifdef DBG_MSG_TRACE_FILE_LOADER
    DBG_MSG_TRACE_FILE_LOADER;

#endif



// Incluse base node object
#include "lib_base_obj_node_tree.mqh"





/*********************************************************************************************************************************************************/
/*                                                                                                                                                       */
/* MQLplus data structures                                                                                                                               */
/*                                                                                                                                                       */
/*********************************************************************************************************************************************************/


    ///////////////////////////////////////
    //
    //  Object Red Black Tree Node
    //

    // Base Red Black Tree object

        #define NODE_TYPE       _object_map_rb_t_node<USER_DATA, USER_KEY>
        #define NODE_SUBTYPE    _object_rb_t_node<USER_KEY>

        template <typename USER_DATA, typename USER_KEY>
        class _object_map_rb_t_node : public NODE_SUBTYPE
        {
            protected:
            // Local storage

				USER_DATA	this_payload;						// User supplied payload data, identified by USER_KEY (USER_KEY is stored as "USER_DATA" in sub_classes)


            public:
            // Constructors / Destructor

                // Default constructor
                _object_map_rb_t_node() :
                    NODE_SUBTYPE    ()
                { ZeroMemory(this_payload); };

                // Copy constructor
                _object_map_rb_t_node(const NODE_TYPE& p_in)
                {
                    NODE_TYPE::remove((NODE_TYPE*)_parent);
                    this_payload = p_in.this_payload;
                    NODE_SUBTYPE(p_in);
                };

                // Destructor
                ~_object_map_rb_t_node()
                { };


            // Tree element functions
/*
                // Insert object into tree
                NODE_TYPE* insert(NODE_TYPE* _root)
                {
                    // Return
                    return(NODE_SUBTYPE::insert(_root));
                };

                // Remove object from tree
                NODE_TYPE* remove(NODE_TYPE* _root, const bool do_not_delete = false)
                {
                    // Return
                    return(NODE_SUBTYPE::remove(_root));
                };
*/

            // Operators
/*
                // Assignment operator
                void operator=(const NODE_TYPE& p_in)
                {
                    NODE_SUBTYPE::operator=((NODE_SUBTYPE)p_in);
                    this_payload = p_in.this_payload;
                };

                // Assignment operator
                void operator=(NODE_TYPE* p_in)
                {
                    NODE_SUBTYPE::operator=((NODE_SUBTYPE*)p_in);
                    this_payload = p_in.this_payload;
                };
*/
        };

        #undef NODE_TYPE
        #undef NODE_SUBTYPE




//
// END MQL data structures                                                                                                                                */
//*********************************************************************************************************************************************************/
#endif // LIB_MQLPLUS_BASE_OBJECT_MAP_RB_TREE_NODE_MQH_INCLUDED
